Index: ode/src/joints/amplus.cpp
===================================================================
--- ode/src/joints/amplus.cpp	(revision 0)
+++ ode/src/joints/amplus.cpp	(working copy)
@@ -0,0 +1,570 @@
+/*************************************************************************
+ *                                                                       *
+ * AMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+
+#include "amplus.h"
+#include "joint_internal.h"
+
+
+
+//****************************************************************************
+// angular motor plus
+
+dxJointAMPlus::dxJointAMPlus( dxWorld *w ) 
+: dxJoint( w )
+{
+  for (int ii=0;ii<3;++ii) {
+    mode[ii] = dAMPlusCone;
+    frame[ii] = 2;
+    dSetZero(axis1[ii],4);
+    axis1[ii][2]=1;
+    dSetZero(axis2[ii],4);
+    axis2[ii][ii]=1;
+    dSetZero(axisRef[ii],4);
+    axisRef[ii][ii]=1;
+    limot[ii].init( world );
+  }
+}
+
+/**
+  Find the current angle and effective axis.
+*/
+dReal dxJointAMPlus::currentAngle(dVector3 axis,int anum)
+{
+  dReal angle=0;
+
+  switch (mode[anum]) {
+    case dAMPlusCone:
+    default: 
+    {
+      // Find the global axes
+      dVector3 ax1, ax2, tmp;
+      getAxis (this, ax1, axis1[anum]);
+      getAxis2(this, ax2, axis2[anum]);
+      // Find the angle between the two anchor axes
+      dReal dotp = dCalcVectorDot3(ax1,ax2);
+      // Even with unit length vectors, fp-error
+      // can push the dot product past one which 
+      // can crash acos().
+      if (dotp>1) dotp=1;  
+      if (dotp<-1) dotp=-1;
+      angle = dAcos(dotp);
+      if (angle!=0) {
+        dCalcVectorCross3(axis,ax2,ax1);
+        dNormalize3(axis);
+      } else {
+        // ***** Find the relative angular velocity
+        // of the bodies, use the orthogonal
+        // component of that if it's non-zero
+
+        // Otherwise, just use the first planespace axis.
+        dPlaneSpace(ax1,axis,tmp);
+      }
+    } break;
+    case dAMPlusProjected:
+    {
+      // Find the axes in global frame
+      dVector3 ax, axP, axQ, tmp;
+      if (frame[anum]==1) { 
+        // The reference axis is the axis of rotation
+        getAxis (this,axis,axisRef[anum]);
+        getAxis2(this, ax,axis2[anum]);
+        getAxis (this,tmp,axis1[anum]);
+        // ***** Things might be backwards here...
+        
+      } else {
+        getAxis2(this,axis,axisRef[anum]);
+        getAxis (this,  ax,axis1[anum]);
+        getAxis2(this, tmp,axis2[anum]);
+
+      }
+      // Find the planespace orthogonal to axis
+      dDirectedPlaneSpace(axis,tmp,axP,axQ);
+  
+      // Project the anchor axis onto the planespace
+      dReal dotp = dCalcVectorDot3(ax,axP);
+      dReal dotq = dCalcVectorDot3(ax,axQ);
+      if (dotp!=0 || dotq!=0) {
+        angle = dAtan2(dotq,dotp);
+      } else {
+        // ***** Should we set the angle to some special value? NaN?
+        // For now, we'll leave it at zero.
+      }
+      if (frame[anum]==1) {
+        dNegateVector3(axis);
+      }
+    } break;
+  }
+  return angle;
+}
+
+void 
+dxJointAMPlus::getSureMaxInfo( SureMaxInfo* info )
+{
+  // For each axis,
+  // If the axis is active +1
+  // If the axis has fudge disabled +1
+  // If the axis has bidirectional constraints enabled +1
+  info->max_m = 0;
+  for (int ii=0;ii<3;++ii) {
+    info->max_m += limot[ii].countSureMaxRows();
+  }
+}
+
+void
+dxJointAMPlus::getInfo1( dxJoint::Info1 *info )
+{
+  info->m = 0;
+  info->nub = 0;
+
+  // For each limot'ed axis
+	for (int ii=0;ii<3;++ii) {
+		if (limot[ii].isActive()) {
+			// Compute the axis/distance and cache them.
+			dReal angle = currentAngle(cacheAxis[ii],ii);
+      // The angle (error) is cached in the limot structure.
+			limot[ii].testRotationalLimit( angle );
+
+			info->m += limot[ii].countRows();
+			info->nub += limot[ii].countUBRows();
+		}
+	}
+}
+
+/**
+  Go through each limit motor and apply the relevant 
+  constraints
+*/
+void dxJointAMPlus::getInfo2( dxJoint::Info2 *info )
+{
+  int row = 0;
+  for (int ii = 0;ii<3;++ii) {
+    row += limot[ii].addRotationalLimot( this, info, cacheAxis[ii], row );
+  }
+}
+
+dJointType dxJointAMPlus::type() const
+{
+    return dJointTypeAMPlus;
+}
+
+
+size_t dxJointAMPlus::size() const
+{
+    return sizeof( *this );
+}
+
+/////////////////////////////////////////////////////////////
+// Public API functions
+/////////////////////////////////////////////////////////////
+void dJointSetAMPlusParam( dJointID j, int parameter, dReal value )
+{
+    dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+    dAASSERT( joint );
+    checktype( joint, AMPlus );
+    int anum = parameter >> 8;
+    if ( anum < 0 ) anum = 0;
+    if ( anum > 2 ) anum = 2;
+    parameter &= 0xff;
+    joint->limot[anum].set( parameter, value );
+}
+
+dReal dJointGetAMPlusParam( dJointID j, int parameter )
+{
+    dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+    dAASSERT( joint );
+    checktype( joint, AMPlus );
+    int anum = parameter >> 8;
+    if ( anum < 0 ) anum = 0;
+    if ( anum > 2 ) anum = 2;
+    parameter &= 0xff;
+    return joint->limot[anum].get( parameter );
+}
+
+void dJointSetAMPlusAxis1( dJointID j, int anum, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2  );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  setAxes(j,x,y,z,joint->axis1[anum],NULL);
+}
+
+void dJointSetAMPlusAxis1Rel( dJointID j, int anum, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+  
+  joint->axis1[anum][0] = x;
+  joint->axis1[anum][1] = y;
+  joint->axis1[anum][2] = z;
+  dNormalize3(joint->axis1[anum]);
+}
+
+void dJointSetAMPlusAxis1V( dJointID j, int anum, const dVector3 ax)
+{
+  dJointSetAMPlusAxis1(j,anum,ax[0],ax[1],ax[2]);
+}
+
+void dJointSetAMPlusAxis1RelV( dJointID j, int anum, const dVector3 ax)
+{
+  dJointSetAMPlusAxis1Rel(j,anum,ax[0],ax[1],ax[2]);
+}
+
+void dJointSetAMPlusAxis2( dJointID j, int anum, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  setAxes(j,x,y,z,NULL,joint->axis2[anum]);
+}
+
+void dJointSetAMPlusAxis2Rel( dJointID j, int anum, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  joint->axis2[anum][0] = x;
+  joint->axis2[anum][1] = y;
+  joint->axis2[anum][2] = z;
+  dNormalize3(joint->axis2[anum]);
+}
+
+void dJointSetAMPlusAxis2V( dJointID j, int anum, const dVector3 ax)
+{
+  dJointSetAMPlusAxis2(j,anum,ax[0],ax[1],ax[2]);
+}
+void dJointSetAMPlusAxis2RelV( dJointID j, int anum, const dVector3 ax)
+{
+  dJointSetAMPlusAxis2Rel(j,anum,ax[0],ax[1],ax[2]);
+}
+
+void dJointSetAMPlusAxisRef( dJointID j, int anum, int frame, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 && frame >= 1 && frame <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  joint->frame[anum] = frame;
+  if (frame==1) {
+    setAxes(j,x,y,z,joint->axisRef[anum],NULL);
+  } else {
+    setAxes(j,x,y,z,NULL,joint->axisRef[anum]);
+  }
+}
+
+void dJointSetAMPlusAxisRefRel( dJointID j, int anum, int frame, dReal x, dReal y, dReal z )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 && frame >= 1 && frame <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  joint->frame[anum] = frame;
+  joint->axisRef[anum][0] = x;
+  joint->axisRef[anum][1] = y;
+  joint->axisRef[anum][2] = z;
+  dNormalize3(joint->axisRef[anum]);
+}
+
+void dJointSetAMPlusAxisRefV( dJointID j, int anum, int frame, const dVector3 ax)
+{
+  dJointSetAMPlusAxisRef(j,anum,frame,ax[0],ax[1],ax[2]);
+}
+
+void dJointSetAMPlusAxisRefRelV( dJointID j, int anum, int frame, const dVector3 ax)
+{
+  dJointSetAMPlusAxisRefRel(j,anum,frame,ax[0],ax[1],ax[2]);
+}
+
+
+void dJointSetAMPlusMode( dJointID j, int anum, int mode )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  joint->mode[anum]=mode;
+}
+
+/**
+  Turn this joint into an anchorless hinge.
+  We associate the axis with the first body
+  and its planespace with the second body.
+  We constrain those to be orthogonal.
+*/
+void dJointSetAMPlusHingeV( dJointID j, const dVector3 ax )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint );
+  checktype( joint, AMPlus );
+
+  dVector3 pp,qq;
+  //ax[0]=x; ax[1]=y; ax[2]=z;
+  dPlaneSpace(ax,pp,qq);
+
+  setAxes(j,ax[0],ax[1],ax[2],joint->axis1[0],joint->axisRef[2]);
+  //setAxes(j,ax[0],ax[1],ax[2],joint->axisRef[2],0);
+  setAxes(j,ax[0],ax[1],ax[2],joint->axis1[1],0);
+  setAxes(j,pp[0],pp[1],pp[2],joint->axis1[2],joint->axis2[2]);
+  setAxes(j,pp[0],pp[1],pp[2], NULL,joint->axis2[0]);
+  setAxes(j,qq[0],qq[1],qq[2], NULL,joint->axis2[1]);
+
+  joint->mode[0]=joint->mode[1]=dAMPlusCone;
+  
+  joint->mode[2]=dAMPlusProjected;
+  joint->frame[2]=2;
+
+  // Set the orthogonality constraints.
+  dReal aa = M_PI/2;
+  dJointSetAMPlusParam(j,dParamLoStop1,aa);
+  dJointSetAMPlusParam(j,dParamHiStop1,aa);
+  dJointSetAMPlusParam(j,dParamLoStop2,aa);
+  dJointSetAMPlusParam(j,dParamHiStop2,aa);
+}
+
+void dJointSetAMPlusHinge( dJointID j, dReal x, dReal y, dReal z)
+{
+  dVector3 ax;
+  ax[0] = x;
+  ax[1] = y;
+  ax[2] = z;
+
+  dJointSetAMPlusHingeV(j,ax);
+}
+
+/**
+  We constrain ax1 wrt body1 to be orthogonal to ax2 wrt body 2
+  and then provide motors around these 2 axes.
+*/
+void dJointSetAMPlusUniversalV( dJointID j, const dVector3 ax1, const dVector3 ax2)
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint );
+  checktype( joint, AMPlus );
+
+  setAxes(j,ax1[0],ax1[1],ax1[2],joint->axis1[0],joint->axis2[2]);
+  setAxes(j,ax1[0],ax1[1],ax1[2],joint->axisRef[1],0);
+  setAxes(j,ax1[0],ax1[1],ax1[2],joint->axis1[2],0);
+
+  setAxes(j,ax2[0],ax2[1],ax2[2],joint->axis1[1],joint->axis2[0]);
+  setAxes(j,ax2[0],ax2[1],ax2[2],0,joint->axis2[1]);
+  setAxes(j,ax2[0],ax2[1],ax2[2],0,joint->axisRef[2]);
+
+  joint->mode[0] = dAMPlusCone;
+  joint->mode[1] = joint->mode[2] = dAMPlusProjected;
+  joint->frame[1]=1;
+  joint->frame[2]=2;
+
+  // Constrain the axes to be orthogonal
+  dReal aa = M_PI/2;
+  dJointSetAMPlusParam(j,dParamLoStop1,aa);
+  dJointSetAMPlusParam(j,dParamHiStop1,aa);
+}
+
+void dJointSetAMPlusUniversal( dJointID j, dReal x1, dReal y1, dReal z1,
+																			dReal x2, dReal y2, dReal z2)
+{
+  dVector3 ax1,ax2;
+
+  ax1[0]=x1;ax1[1]=y1;ax1[2]=z1;
+  ax2[0]=x2;ax2[1]=y2;ax2[2]=z2;
+
+  dJointSetAMPlusUniversalV(j,ax1,ax2);
+}
+
+void dJointGetAMPlusAxis1( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  getAxis( j,result,joint->axis1[anum]);   
+}
+
+void dJointGetAMPlusAxis1Rel( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dCopyVector3(result,joint->axis1[anum]);  
+}
+
+void dJointGetAMPlusAxis2( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  getAxis2( j,result,joint->axis2[anum]);   
+}
+
+void dJointGetAMPlusAxis2Rel( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dCopyVector3(result,joint->axis2[anum]);  
+}
+
+void dJointGetAMPlusAxisRef( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  if (joint->frame[anum]==1) {
+    getAxis( j,result,joint->axisRef[anum]);   
+  } else {
+    getAxis2( j,result,joint->axisRef[anum]);   
+  }
+}
+
+void dJointGetAMPlusAxisRefRel( dJointID j, int anum, dVector3 result )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dCopyVector3(result,joint->axisRef[anum]);  
+}
+
+
+int dJointGetAMPlusAxisRefFrame( dJointID j, int anum )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+  
+  return joint->frame[anum];
+}
+
+int dJointGetAMPlusMode( dJointID j, int anum )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+  
+  return joint->mode[anum];
+}
+
+void dJointGetAMPlusEffectiveAxis( const dJointID j, int anum, dVector3 res )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  joint->currentAngle(res,anum);
+}
+
+dReal dJointGetAMPlusAngle( dJointID j, int anum )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dVector3 ax;
+  return joint->currentAngle(ax,anum);
+}
+
+
+dReal dJointGetAMPlusAngleRate( dJointID j, int anum )
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dVector3 ax;
+  joint->currentAngle(ax,anum);
+
+  dReal rate=0;
+
+  // Backwards?
+  rate+=dCalcVectorDot3( joint->node[0].body->avel, ax);
+  if (joint->node[1].body) {
+    rate-=dCalcVectorDot3( joint->node[1].body->avel, ax);
+  }
+  return rate;
+}
+
+
+void dJointAddAMPlusTorque( dJointID j, int anum, dReal torque)
+{
+  dxJointAMPlus* joint = ( dxJointAMPlus* )j;
+  dAASSERT( joint && anum >= 0 && anum <= 2 );
+  checktype( joint, AMPlus );
+  if ( anum < 0 ) anum = 0;
+  if ( anum > 2 ) anum = 2;
+
+  dVector3 ax;
+  joint->currentAngle(ax,anum);
+  dScaleVector3(ax,torque);
+
+  dBodyAddTorque( joint->node[0].body, ax[0], ax[1], ax[2] );
+  if (joint->node[1].body) {
+    dBodyAddTorque( joint->node[1].body, -ax[0], -ax[1], -ax[2] );
+  }
+}
+
+
+
Index: ode/src/joints/amplus.h
===================================================================
--- ode/src/joints/amplus.h	(revision 0)
+++ ode/src/joints/amplus.h	(working copy)
@@ -0,0 +1,63 @@
+/*************************************************************************
+ *                                                                       *
+ * AMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+#ifndef _ODE_JOINT_AMPLUS_H_
+#define _ODE_JOINT_AMPLUS_H_
+
+#include "joint.h"
+
+
+// angular motor plus
+
+struct dxJointAMPlus : public dxJoint
+{
+  int mode[3];              // a dAMPlusXXX constant
+  int frame[3];               // what the reference axes are relative to (b1,b2)
+  dVector3 axis1[3];		    // axes wrt the first body
+  dVector3 axis2[3];        // axes wrt the second body
+  // reference axes are the axis around which
+  // axis1 and axis2 spin and around which their 
+  // angles are measured
+  // This should be orthogonal to the associated axis
+  // determined by "rel"
+  // We don't enforce orthogonality so that the behavior
+  // isn't order dependent (you don't have to set one before the other)
+  dVector3 axisRef[3];      
+  dxJointLimitMotor limot[3]; // limit+motor info for axes
+  dVector3 cacheAxis[3];
+
+
+    dxJointAMPlus( dxWorld *w );
+
+  dReal currentAngle(dVector3 axis,int anum);
+  
+  virtual void getSureMaxInfo( SureMaxInfo* info );
+  virtual void getInfo1( Info1* info );
+  virtual void getInfo2( Info2* info );
+  virtual dJointType type() const;
+  virtual size_t size() const;
+};
+
+
+#endif
+
Index: ode/src/joints/hinge.cpp
===================================================================
--- ode/src/joints/hinge.cpp	(revision 1903)
+++ ode/src/joints/hinge.cpp	(working copy)
@@ -47,7 +47,7 @@
 void 
 dxJointHinge::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 5 + limot.countSureMaxRows();
 }
 
 
@@ -55,22 +55,20 @@
 dxJointHinge::getInfo1( dxJoint::Info1 *info )
 {
     info->nub = 5;
-
-    // see if joint is powered
-    if ( limot.fmax > 0 )
-        info->m = 6; // powered hinge needs an extra constraint row
-    else info->m = 5;
-
+    info->m = 5;
+    
     // see if we're at a joint limit.
+    limot.limit=0;
     if (( limot.lostop >= -M_PI || limot.histop <= M_PI ) &&
         limot.lostop <= limot.histop )
     {
         dReal angle = getHingeAngle( node[0].body,
             node[1].body,
             axis1, qrel );
-        if ( limot.testRotationalLimit( angle ) )
-            info->m = 6;
+        limot.testRotationalLimit( angle );
     }
+    info->m += limot.countRows();
+    info->nub += limot.countUBRows();
 }
 
 
@@ -146,7 +144,8 @@
     info->c[4] = k * dCalcVectorDot3( b, q );
 
     // if the hinge is powered, or has joint limits, add in the stuff
-    limot.addLimot( this, info, 5, ax1, 1 );
+    //limot.addLimot( this, info, 5, ax1, 1 );
+    limot.addRotationalLimot( this, info, ax1, 5 );
 }
 
 
Index: ode/src/joints/hinge2.cpp
===================================================================
--- ode/src/joints/hinge2.cpp	(revision 1903)
+++ ode/src/joints/hinge2.cpp	(working copy)
@@ -74,7 +74,7 @@
 void 
 dxJointHinge2::getSureMaxInfo( SureMaxInfo* info )
 {
-    info->max_m = 6;
+  info->max_m = 4 + limot1.countSureMaxRows() + limot2.countSureMaxRows();
 }
 
 
@@ -92,11 +92,12 @@
         dReal angle = measureAngle();
         limot1.testRotationalLimit( angle );
     }
-    if ( limot1.limit || limot1.fmax > 0 ) info->m++;
+    info->m += limot1.countRows();
+    info->nub+= limot1.countUBRows();
 
     // see if we're powering axis 2 (we currently never limit this axis)
-    limot2.limit = 0;
-    if ( limot2.fmax > 0 ) info->m++;
+    info->m+=limot2.countRows();
+    info->nub+=limot2.countUBRows();
 }
 
 
@@ -171,10 +172,10 @@
     info->c[3] = k * ( c0 * s - joint->s0 * c );
 
     // if the axis1 hinge is powered, or has joint limits, add in more stuff
-    int row = 4 + limot1.addLimot( this, info, 4, ax1, 1 );
+    int row = 4 + limot1.addRotationalLimot( this, info, ax1, 4 );
 
     // if the axis2 hinge is powered, add in more stuff
-    limot2.addLimot( this, info, row, ax2, 1 );
+    limot2.addRotationalLimot( this, info, ax2, row );
 
     // set parameter for the suspension
     info->cfm[0] = susp_cfm;
